Thursday, August 27, 2015

Course Schedule II | Leetcode

There are a total of n courses you have to take, labeled from 0 to n - 1.

Some courses may have prerequisites, for example to take course 0 you have to first take course 1, which is expressed as a pair: [0,1]

Given the total number of courses and a list of prerequisite pairs, return the ordering of courses you should take to finish all courses.

There may be multiple correct orders, you just need to return one of them. If it is impossible to finish all courses, return an empty array.

For example:
2, [[1,0]]
There are a total of 2 courses to take. To take course 1 you should have finished course 0. So the correct course order is [0,1]
4, [[1,0],[2,0],[3,1],[3,2]]
There are a total of 4 courses to take. To take course 3 you should have finished both courses 1 and 2. Both courses 1 and 2 should be taken after you finished course 0. So one correct course order is [0,1,2,3]. Another correct ordering is[0,2,1,3].

Note:
The input prerequisites is a graph represented by a list of edges, not adjacency matrices. Read more about how a graph is represented.


Hints:
  1. This problem is equivalent to finding the topological order in a directed graph. If a cycle exists, no topological ordering exists and therefore it will be impossible to take all courses.
  2. Topological Sort via DFS - A great video tutorial (21 minutes) on Coursera explaining the basic concepts of Topological Sort.
  3. Topological sort could also be done via BFS.
---

Solution: I prefer using DFS to detect a cycle because the algorithm seems simpler than using topological sort. The trick is the order to add the nodes. For the answer array, start adding from the last position to the first after we have determined that there is no cycle.
public class Solution {
    private int[] answer;
    private int index = 0;
    
    private class Node {
        private int val;
        private List<Node> inEdges = new ArrayList<>();
        private boolean seen;
        private boolean inRecursiveStack;
        
        private Node(int val) { this.val = val; }
        
        private boolean hasCycle() {
            if (seen) return false;
            if (inRecursiveStack) return true;
            inRecursiveStack = true;
            
            for (Node node: inEdges) {
                if (node.hasCycle()) return true;
            }
            
            answer[--index] = val;
            inRecursiveStack = false;
            seen = true;
            return false;
        }
    }
    
    public int[] findOrder(int numCourses, int[][] prerequisites) {
        Node[] graph = new Node[numCourses];
        for (int i = 0; i < numCourses; i++) {
            graph[i] = new Node(i);
        }
        
        for (int[] prereq: prerequisites) {
            Node in = graph[prereq[0]];
            Node out = graph[prereq[1]];
            out.inEdges.add(in);
        }
        
        answer = new int[numCourses];
        index = numCourses;
        
        for (int i = 0; i < numCourses; i++) {
            if (graph[i].hasCycle()) {
                return new int[0];
            }
        }
        
        return answer;
    }
}

No comments: